/* Example program for the Allegro library, by Johnny13
 * This program display the axis and button state of your Joypad.
 */

#include<allegro.h>

#define MC(RR,GG,BB) makecol(RR,GG,BB)

int main()
{
   int i; allegro_init(); install_keyboard();
#ifdef ALLEGRO_DOS
   install_joystick(JOY_TYPE_8BUTTON);
#else
   install_joystick(JOY_TYPE_AUTODETECT);
#endif
   set_gfx_mode(GFX_AUTODETECT_FULLSCREEN,320,200,0,0);
   clear_to_color(screen,MC(128,128,128));
   textprintf_ex(screen,font,0,183,0,-1,"%s %d.%d",allegro_id,os_version,os_revision);
   textprintf_ex(screen,font,0,192,0,-1,"%s %daxis %dbuttons",joystick_driver->name,joy[0].stick[0].num_axis,joy[0].num_buttons);

   while (!keypressed()) {
      poll_joystick();
      rectfill(screen,30,40,93,103,MC(255,255,255));
      textout_ex(screen,font,"+",
      joy[0].stick[0].axis[0].d1?30:joy[0].stick[0].axis[0].d2?85:60,
      joy[0].stick[0].axis[1].d1?40:joy[0].stick[0].axis[1].d2?95:68,MC(0,0,255),MC(255,255,255));
      rectfill(screen,101,40,112,103,MC(255,255,255));
      rectfill(screen,101,71,112,71+(joy[0].stick[0].axis[2].pos>>2),MC(0,255,0));
      rect(screen,29,39,94,104,0);
      rect(screen,100,39,113,104,0);
      for (i=0;i<3;i++)
      textprintf_ex(screen,font,i*40,107,MC(0,0,255),MC(128,128,128),"%4d",joy[0].stick[0].axis[i].pos);
      textprintf_ex(screen,font,115,97,MC(0,255,0),MC(128,128,128),"%2d%2d",joy[0].stick[0].axis[2].d1,joy[0].stick[0].axis[2].d2);
      for (i=0;i<joy[0].num_buttons;i++) {
         circlefill(screen,30+i*26,133,8,(joy[0].button[i].b)?MC(255,0,0):MC(255,255,255));
         circle(screen,30+i*26,133,9,0);
         textprintf_centre_ex(screen,font,32+i*26,145,MC(0,0,255),MC(128,128,128),"B%u",i+1);
      }
   }
   return 0;
}END_OF_MAIN();
